

#include <windows.h>
#include <iostream>

using std::cerr;
using std::cout;
using std::endl;

int main(int argc, char **argv) {

	int x, y, sx, sy, sw, sh;
	char path[MAX_PATH], inifilename[MAX_PATH], logfilename[MAX_PATH], transcript[256];
	char *p;
	UINT id_clear, id_selfplay, id_learn, id_lstart, id_inactive, id_board, id_panel;

	p=path+GetModuleFileName( NULL, path, MAX_PATH );
	while(*p != '\\')
		p--;
	*(++p)='\0';
	strcpy(inifilename, path);
	strcat(inifilename, "zebra.ini");
	GetPrivateProfileString("Strings", "Transcript", "", transcript, 256, inifilename);
	p=logfilename+GetPrivateProfileString("Strings", "ZebraPath", "", logfilename, MAX_PATH, inifilename);
	p--;
	if(*p=='\\')
		strcat(logfilename, "zebra.log");
	else
		strcat(logfilename, "\\zebra.log");
	id_clear    = GetPrivateProfileInt("IDItem", "Clear", 400, inifilename);
	id_selfplay = GetPrivateProfileInt("IDItem", "SelfPlay", 405, inifilename);
	id_learn    = GetPrivateProfileInt("IDItem", "Learn", 1700, inifilename);
	id_lstart   = GetPrivateProfileInt("IDItem", "LStart", 1900, inifilename);
	id_inactive = GetPrivateProfileInt("IDItem", "Inactive", 604, inifilename);
	id_board    = GetPrivateProfileInt("IDItem", "Board", 0xffffff35, inifilename);
	id_panel    = GetPrivateProfileInt("IDItem", "Panel", 0xffffff34, inifilename);

	// find handle to main window
	HWND hMainWindow = FindWindow(NULL, "WZebra");
	HWND hBoard = GetDlgItem(hMainWindow, id_board);
	HWND hPanel = GetDlgItem(hMainWindow, id_panel);
	HWND hButton = GetDlgItem(hPanel, id_lstart);
	RECT rect;

	if( hMainWindow == NULL ) {
		cerr << "Error: can't find WZebra. Did you start it?" << endl;
		exit(0);
	}

	int games = 0;
	while( true ) {
		games ++;

		// clear board
		cout << "Game " << games;
		SendMessage(hMainWindow, WM_COMMAND, id_clear, 0);
		Sleep(100);

		// load transcript
		if(transcript[0] != '\0'){
			SendMessage(hMainWindow, WM_COMMAND, id_inactive, 0);
			Sleep(100);
			GetWindowRect(hBoard, &rect);
			sw=rect.right-rect.left; sh=rect.bottom-rect.top;
			if(sw>sh){
				x=y=sh/9.33;
				sx=(sw-x*7)*0.5;
				sy=(sh-y*7)*0.5;
				sw=x;	sh=y;
			}else{
				x=y=sw/9.33;
				sx=(sw-x*7)*0.5;
				sy=(sh-y*7)*0.5;
				sw=x;	sh=y;
			}
			for(p=transcript;*p;p++){
				if(*p>='a' && *p<='h')
					x=(*p-'a')*sw+sx;
				else if(*p>='A' && *p<='H')
					x=(*p-'A')*sw+sx;
				else{
					MessageBox(NULL, "Invalid caracter in transcript.", "Error", 0);
					exit(0);
				}
				p++;
				if(*p>='1' && *p<='8')
					y=(*p-'1')*sh+sy;
				else{
					MessageBox(NULL, "Invalid caracter in transcript.", "Error", 0);
					exit(0);
				}
				SendMessage(hBoard, WM_LBUTTONDOWN, 0, (y<<16)+x);
				Sleep(50);
				SendMessage(hBoard, WM_LBUTTONUP, 0, (y<<16)+x);
				Sleep(50);
			}
		}

		// self play game
		cout << " Selfplaying...";
		Sleep(200);
		SendMessage(hMainWindow, WM_COMMAND, id_selfplay, 0);
		Sleep(200);
		while(!IsWindowEnabled(hButton)) Sleep(100);
		SendMessage(hButton, WM_LBUTTONDOWN, 0, 0);
		SendMessage(hButton, WM_LBUTTONUP, 0, 0);

		// learn game
		cout << " Learning..." << endl;
		SendMessage(hMainWindow, WM_COMMAND, id_learn, 0);
		remove(logfilename);
	}

	return 0;
}

